JsonCpp project page | Classes | Namespace | JsonCpp home page

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | Friends | List of all members
Json::Value Class Reference

Represents a JSON value. More...

`#include <json/value.h>`

Collaboration diagram for Json::Value:

## Public Types
typedef std::vector< String > | Members
typedef ValueIterator | iterator
typedef ValueConstIterator | const_iterator
typedef Json::UInt | UInt
typedef Json::Int | Int
typedef Json::UInt64 | UInt64
typedef Json::Int64 | Int64
typedef Json::LargestInt | LargestInt
typedef Json::LargestUInt | LargestUInt
typedef Json::ArrayIndex | ArrayIndex
typedef std::string | value_type

## Public Member Functions
| Value (ValueType type=nullValue)
| Create a default Value of the given type. More...
| Value (Int value)
| Value (UInt value)
| Value (Int64 value)
| Value (UInt64 value)
| Value (double value)
| Value (const char *value)
| Copy til first 0. (NULL causes to seg-fault.) More...
| Value (const char *begin, const char *end)
| Copy all, incl zeroes. More...
| Value (const StaticString &value)
| Constructs a value from a static string. More...
| Value (const String &value)
| Copy data() til size(). More...
| Value (bool value)
| Value (const Value &other)
| Value (Value &&other)
| ~Value ()
Value & | operator= (const Value &other)
Value & | operator= (Value &&other)
void | swap (Value &other)
| Swap everything. More...
void | swapPayload (Value &other)
| Swap values but leave comments and source offsets in place. More...
void | copy (const Value &other)
| copy everything. More...
void | copyPayload (const Value &other)
| copy values but leave comments and source offsets in place. More...
ValueType | type () const
bool | operator< (const Value &other) const
| Compare payload only, not comments etc. More...
bool | operator<= (const Value &other) const
bool | operator>= (const Value &other) const
bool | operator> (const Value &other) const
bool | operator== (const Value &other) const
bool | operator!= (const Value &other) const
int | compare (const Value &other) const
const char * | asCString () const
| Embedded zeroes could cause you trouble! More...
String | asString () const
| Embedded zeroes are possible. More...
bool | getString (char const **begin, char const **end) const
| Get raw char* of string-value. More...
Int | asInt () const
UInt | asUInt () const
Int64 | asInt64 () const
UInt64 | asUInt64 () const
LargestInt | asLargestInt () const
LargestUInt | asLargestUInt () const
float | asFloat () const
double | asDouble () const
bool | asBool () const
bool | isNull () const
bool | isBool () const
bool | isInt () const
bool | isInt64 () const
bool | isUInt () const
bool | isUInt64 () const
bool | isIntegral () const
bool | isDouble () const
bool | isNumeric () const
bool | isString () const
bool | isArray () const
bool | isObject () const
bool | isConvertibleTo (ValueType other) const
ArrayIndex | size () const
| Number of values in array or object. More...
bool | empty () const
| Return true if empty array, empty object, or null; otherwise, false. More...
| operator bool () const
| Return !isNull() More...
void | clear ()
| Remove all object members and array elements. More...
void | resize (ArrayIndex newSize)
| Resize the array to newSize elements. More...
Value & | operator[] (ArrayIndex index)
| Access an array element (zero based index ). More...
Value & | operator[] (int index)
| Access an array element (zero based index ). More...
const Value & | operator[] (ArrayIndex index) const
| Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.) More...
const Value & | operator[] (int index) const
| Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.) More...
Value | get (ArrayIndex index, const Value &defaultValue) const
| If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue. More...
bool | isValidIndex (ArrayIndex index) const
| Return true if index < size(). More...
Value & | append (const Value &value)
| Append value to array at the end. More...
Value & | append (Value &&value)
Value & | operator[] (const char *key)
| Access an object value by name, create a null member if it does not exist. More...
const Value & | operator[] (const char *key) const
| Access an object value by name, returns null if there is no member with that name. More...
Value & | operator[] (const String &key)
| Access an object value by name, create a null member if it does not exist. More...
const Value & | operator[] (const String &key) const
| Access an object value by name, returns null if there is no member with that name. More...
Value & | operator[] (const StaticString &key)
| Access an object value by name, create a null member if it does not exist. More...
Value | get (const char *key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise. More...
Value | get (const char *begin, const char *end, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise. More...
Value | get (const String &key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise. More...
Value const * | find (char const *begin, char const *end) const
| Most general and efficient version of isMember()const, get()const, and operator[]const. More...
Value * | demand (char const *begin, char const *end)
| Most general and efficient version of object-mutators. More...
void | removeMember (const char *key)
| Remove and return the named member. More...
void | removeMember (const String &key)
| Same as removeMember(const char*) More...
bool | removeMember (const char *key, Value *removed)
| Same as removeMember(const char* begin, const char* end, Value* removed), but 'key' is null-terminated. More...
bool | removeMember (String const &key, Value *removed)
| Remove the named map member. More...
bool | removeMember (const char *begin, const char *end, Value *removed)
| Same as removeMember(String const& key, Value* removed) More...
bool | removeIndex (ArrayIndex index, Value *removed)
| Remove the indexed array element. More...
bool | isMember (const char *key) const
| Return true if the object has a member named key. More...
bool | isMember (const String &key) const
| Return true if the object has a member named key. More...
bool | isMember (const char *begin, const char *end) const
| Same as isMember(String const& key)const. More...
Members | getMemberNames () const
| Return a list of the member names. More...
| __declspec (deprecated("Use setComment(String const&) instead.")) void setComment(const char *comment
void | setComment (const char *comment, size_t len, CommentPlacement placement)
| Comments must be //... or /* ... *‍/. More...
void | setComment (String comment, CommentPlacement placement)
| Comments must be //... or /* ... *‍/. More...
bool | hasComment (CommentPlacement placement) const
String | getComment (CommentPlacement placement) const
| Include delimiters and embedded newlines. More...
String | toStyledString () const
const_iterator | begin () const
const_iterator | end () const
iterator | begin ()
iterator | end ()
void | setOffsetStart (ptrdiff_t start)
void | setOffsetLimit (ptrdiff_t limit)
ptrdiff_t | getOffsetStart () const
ptrdiff_t | getOffsetLimit () const

## Static Public Member Functions
static Value const & | nullSingleton ()

## Public Attributes
CommentPlacement | placement
unsigned int | value_type_: 8
unsigned int | allocated_: 1

## Static Public Attributes
static const Value & | null = Value::nullSingleton()
static const Value & | nullRef = Value::nullSingleton()
static const LargestInt | minLargestInt = LargestInt(~(LargestUInt(-1) / 2))
| Minimum signed integer value that can be stored in a Json::Value. More...
static const LargestInt | maxLargestInt = LargestInt(LargestUInt(-1) / 2)
| Maximum signed integer value that can be stored in a Json::Value. More...
static const LargestUInt | maxLargestUInt = LargestUInt(-1)
| Maximum unsigned integer value that can be stored in a Json::Value. More...
static const Int | minInt = Int(~(UInt(-1) / 2))
| Minimum signed int value that can be stored in a Json::Value. More...
static const Int | maxInt = Int(UInt(-1) / 2)
| Maximum signed int value that can be stored in a Json::Value. More...
static const UInt | maxUInt = UInt(-1)
| Maximum unsigned int value that can be stored in a Json::Value. More...
static const Int64 | minInt64 = Int64(~(UInt64(-1) / 2))
| Minimum signed 64 bits int value that can be stored in a Json::Value. More...
static const Int64 | maxInt64 = Int64(UInt64(-1) / 2)
| Maximum signed 64 bits int value that can be stored in a Json::Value. More...
static const UInt64 | maxUInt64 = UInt64(-1)
| Maximum unsigned 64 bits int value that can be stored in a Json::Value. More...
static const UInt | defaultRealPrecision = 17
| Default precision for real value for string representation. More...

## Friends
class | ValueIteratorBase

## Detailed Description

Represents a JSON value.

This class is a discriminated union wrapper that can represents a:

- signed integer [range: Value::minInt - Value::maxInt]
- unsigned integer (range: 0 - Value::maxUInt)
- double
- UTF-8 string
- boolean
- 'null'
- an ordered list of Value
- collection of name/value pairs (javascript object)

The type of the held value is represented by a ValueType and can be obtained using type().

Values of an objectValue or arrayValue can be accessed using operator[]() methods. Non-const methods will automatically create the a nullValue element if it does not exist. The sequence of an arrayValue will be automatically resized and initialized with nullValue. resize() can be used to enlarge or truncate an arrayValue.

The get() methods can be used to obtain default value in the case the required element does not exist.

It is possible to iterate over the list of member keys of an object using the getMemberNames() method.

Note
  Value string-length fit in size_t, but keys must be < 2^30. (The reason is an implementation detail.) A #CharReader will raise an exception if a bound is exceeded to avoid security holes in your app, but the Value API does not check bounds. That is the responsibility of the caller.

Definition at line 176 of file value.h.

## Member Typedef Documentation

## ◆ ArrayIndex

typedef Json::ArrayIndex Json::Value::ArrayIndex

Definition at line 191 of file value.h.

## ◆ const_iterator

typedef ValueConstIterator Json::Value::const_iterator

Definition at line 182 of file value.h.

## ◆ Int

typedef Json::Int Json::Value::Int

Definition at line 184 of file value.h.

## ◆ Int64

typedef Json::Int64 Json::Value::Int64

Definition at line 187 of file value.h.

## ◆ iterator

typedef ValueIterator Json::Value::iterator

Definition at line 181 of file value.h.

## ◆ LargestInt

typedef Json::LargestInt Json::Value::LargestInt

Definition at line 189 of file value.h.

## ◆ LargestUInt

typedef Json::LargestUInt Json::Value::LargestUInt

Definition at line 190 of file value.h.

## ◆ Members

typedef std::vector<String> Json::Value::Members

Definition at line 180 of file value.h.

## ◆ UInt

typedef Json::UInt Json::Value::UInt

Definition at line 183 of file value.h.

## ◆ UInt64

typedef Json::UInt64 Json::Value::UInt64

Definition at line 186 of file value.h.

## ◆ value_type

typedef std::string Json::Value::value_type

Definition at line 194 of file value.h.

## Constructor & Destructor Documentation

## ◆ Value() [1/13]

Json::Value::Value | ( | ValueType | type = `nullValue` | ) |

Create a default Value of the given type.

This is a very useful constructor. To create an empty array, pass arrayValue. To create an empty object, pass objectValue. Another Value can then be set to this one by assignment. This is useful since clear() and resize() will not alter types.

    Examples:

Json::Value null_value; // null
Json::Value arr_value(Json::arrayValue); // []
Json::Value obj_value(Json::objectValue); // {}

Default constructor initialization must be equivalent to: memset( this, 0, sizeof(Value) ) This optimization is used in ValueInternalMap fast allocator.

Definition at line 369 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

## ◆ Value() [2/13]

Json::Value::Value | ( | Int | value | ) |

Definition at line 398 of file json_value.cpp.

References Json::intValue.

## ◆ Value() [3/13]

Json::Value::Value | ( | UInt | value | ) |

Definition at line 403 of file json_value.cpp.

References Json::uintValue.

## ◆ Value() [4/13]

Json::Value::Value | ( | Int64 | value | ) |

Definition at line 408 of file json_value.cpp.

References Json::intValue.

## ◆ Value() [5/13]

Json::Value::Value | ( | UInt64 | value | ) |

Definition at line 412 of file json_value.cpp.

References Json::uintValue.

## ◆ Value() [6/13]

Json::Value::Value | ( | double | value | ) |

Definition at line 418 of file json_value.cpp.

References Json::realValue.

## ◆ Value() [7/13]

Json::Value::Value | ( | const char * | value | ) |

Copy til first 0. (NULL causes to seg-fault.)

Definition at line 423 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), JSON_ASSERT_MESSAGE, and Json::stringValue.

## ◆ Value() [8/13]

Json::Value::Value | ( | const char * | begin,
|  | const char * | end
| ) |  |

Copy all, incl zeroes.

Definition at line 431 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), and Json::stringValue.

## ◆ Value() [9/13]

Json::Value::Value | ( | const StaticString & | value | ) |

Constructs a value from a static string.

Like other value string constructor but do not duplicate the string for internal storage. The given string must remain alive after the call to this constructor.

Note
  This works only for null-terminated strings. (We cannot change the size of this class, so we have nowhere to store the length, which might be computed later for various operations.)

Example of usage:

static StaticString foo("some text");
Json::Value aValue(foo);

Definition at line 443 of file json_value.cpp.

References Json::StaticString::c_str(), and Json::stringValue.

## ◆ Value() [10/13]

Json::Value::Value | ( | const String & | value | ) |

Copy data() til size().

Embedded zeroes too.

Definition at line 437 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), and Json::stringValue.

## ◆ Value() [11/13]

Json::Value::Value | ( | bool | value | ) |

Definition at line 456 of file json_value.cpp.

References Json::booleanValue.

## ◆ Value() [12/13]

Json::Value::Value | ( | const Value & | other | ) |

Definition at line 461 of file json_value.cpp.

## ◆ Value() [13/13]

Json::Value::Value | ( | Value && | other | ) |

Definition at line 466 of file json_value.cpp.

References Json::nullValue, and Json::swap().

## ◆ ~Value()

Json::Value::~Value | ( |  | ) |

Definition at line 471 of file json_value.cpp.

## Member Function Documentation

## ◆ __declspec()

Json::Value::__declspec | ( | deprecated("Use setComment(String const&) instead.") |  | ) | const

Deprecated:
  Always pass len.

## ◆ append() [1/2]

Value & Json::Value::append | ( | const Value & | value | ) |

Append value to array at the end.

Equivalent to jsonvalue[jsonvalue.size()] = value;

Definition at line 1179 of file json_value.cpp.

## ◆ append() [2/2]

Value & Json::Value::append | ( | Value && | value | ) |

Definition at line 1181 of file json_value.cpp.

## ◆ asBool()

bool Json::Value::asBool | ( |  | ) | const

Definition at line 845 of file json_value.cpp.

References Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by Json::CharReaderBuilder::newCharReader(), and Json::StreamWriterBuilder::newStreamWriter().

Here is the caller graph for this function:

## ◆ asCString()

const char * Json::Value::asCString | ( |  | ) | const

Embedded zeroes could cause you trouble!

Definition at line 622 of file json_value.cpp.

References Json::decodePrefixedString(), JSON_ASSERT_MESSAGE, and Json::stringValue.

## ◆ asDouble()

double Json::Value::asDouble | ( |  | ) | const

Definition at line 800 of file json_value.cpp.

References Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ asFloat()

float Json::Value::asFloat | ( |  | ) | const

Definition at line 822 of file json_value.cpp.

References Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ asInt()

Value::Int Json::Value::asInt | ( |  | ) | const

Definition at line 695 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ asInt64()

Value::Int64 Json::Value::asInt64 | ( |  | ) | const

Definition at line 741 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ asLargestInt()

LargestInt Json::Value::asLargestInt | ( |  | ) | const

Definition at line 784 of file json_value.cpp.

## ◆ asLargestUInt()

LargestUInt Json::Value::asLargestUInt | ( |  | ) | const

Definition at line 792 of file json_value.cpp.

## ◆ asString()

String Json::Value::asString | ( |  | ) | const

Embedded zeroes are possible.

Definition at line 660 of file json_value.cpp.

References Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, Json::stringValue, Json::uintValue, and Json::valueToString().

Referenced by Json::StreamWriterBuilder::newStreamWriter().

Here is the caller graph for this function:

## ◆ asUInt()

Value::UInt Json::Value::asUInt | ( |  | ) | const

Definition at line 717 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by Json::StreamWriterBuilder::newStreamWriter().

Here is the caller graph for this function:

## ◆ asUInt64()

Value::UInt64 Json::Value::asUInt64 | ( |  | ) | const

Definition at line 762 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ begin() [1/2]

Value::iterator Json::Value::begin | ( |  | ) |

Definition at line 1539 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

## ◆ begin() [2/2]

Value::const_iterator Json::Value::begin | ( |  | ) | const

Definition at line 1513 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

## ◆ clear()

void Json::Value::clear | ( |  | ) |

Remove all object members and array elements.

Precondition
  type() is arrayValue, objectValue, or nullValue

Postcondition
  type() is unchanged

Definition at line 932 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

## ◆ compare()

int Json::Value::compare | ( | const Value & | other | ) | const

Definition at line 512 of file json_value.cpp.

## ◆ copy()

void Json::Value::copy | ( | const Value & | other | ) |

copy everything.

Definition at line 503 of file json_value.cpp.

## ◆ copyPayload()

void Json::Value::copyPayload | ( | const Value & | other | ) |

copy values but leave comments and source offsets in place.

Definition at line 491 of file json_value.cpp.

## ◆ demand()

Value * Json::Value::demand | ( | char const * | begin,
|  | char const * | end
| ) |  |

Most general and efficient version of object-mutators.

Note
  As stated elsewhere, behavior is undefined if (end-begin) >= 2^30

Returns
  non-zero, but JSON_ASSERT if this is neither object nor nullValue.

Definition at line 1136 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

## ◆ empty()

bool Json::Value::empty | ( |  | ) | const

Return true if empty array, empty object, or null; otherwise, false.

Definition at line 923 of file json_value.cpp.

Referenced by Json::StreamWriterBuilder::validate(), and Json::CharReaderBuilder::validate().

Here is the caller graph for this function:

## ◆ end() [1/2]

Value::iterator Json::Value::end | ( |  | ) |

Definition at line 1552 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

## ◆ end() [2/2]

Value::const_iterator Json::Value::end | ( |  | ) | const

Definition at line 1526 of file json_value.cpp.

References Json::arrayValue, Json::objectValue, and type().

## ◆ find()

Value const * Json::Value::find | ( | char const * | begin,
|  | char const * | end
| ) |  | const

Most general and efficient version of isMember()const, get()const, and operator[]const.

Note
  As stated elsewhere, behavior is undefined if (end-begin) >= 2^30

Definition at line 1123 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

## ◆ get() [1/4]

Value Json::Value::get | ( | ArrayIndex | index,
|  | const Value & | defaultValue
| ) |  | const

If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue.

Definition at line 1116 of file json_value.cpp.

## ◆ get() [2/4]

Value Json::Value::get | ( | const char * | begin,
|  | const char * | end,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy
  key may contain embedded nulls.

Definition at line 1185 of file json_value.cpp.

## ◆ get() [3/4]

Value Json::Value::get | ( | const char * | key,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Definition at line 1191 of file json_value.cpp.

## ◆ get() [4/4]

Value Json::Value::get | ( | const String & | key,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Parameters

  key | may contain embedded nulls.

Definition at line 1194 of file json_value.cpp.

## ◆ getComment()

String Json::Value::getComment | ( | CommentPlacement | placement | ) | const

Include delimiters and embedded newlines.

Definition at line 1491 of file json_value.cpp.

References placement.

## ◆ getMemberNames()

Value::Members Json::Value::getMemberNames | ( |  | ) | const

Return a list of the member names.

If null, return an empty list.

Precondition
  type() is objectValue or nullValue

Postcondition
  if type() was nullValue, it remains nullValue

Definition at line 1277 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

Referenced by Json::StreamWriterBuilder::validate(), and Json::CharReaderBuilder::validate().

Here is the caller graph for this function:

## ◆ getOffsetLimit()

ptrdiff_t Json::Value::getOffsetLimit | ( |  | ) | const

Definition at line 1501 of file json_value.cpp.

Referenced by Json::Reader::pushError().

Here is the caller graph for this function:

## ◆ getOffsetStart()

ptrdiff_t Json::Value::getOffsetStart | ( |  | ) | const

Definition at line 1499 of file json_value.cpp.

Referenced by Json::Reader::pushError().

Here is the caller graph for this function:

## ◆ getString()

bool Json::Value::getString | ( | char const ** | begin,
|  | char const ** | end
| ) |  | const

Get raw char* of string-value.

Returns
  false if !string. (Seg-fault if str or end are NULL.)

Definition at line 648 of file json_value.cpp.

References Json::decodePrefixedString(), and Json::stringValue.

## ◆ hasComment()

bool Json::Value::hasComment | ( | CommentPlacement | placement | ) | const

Definition at line 1487 of file json_value.cpp.

References placement.

Referenced by toStyledString().

Here is the caller graph for this function:

## ◆ isArray()

bool Json::Value::isArray | ( |  | ) | const

Definition at line 1439 of file json_value.cpp.

References Json::arrayValue.

Referenced by Json::Path::make(), Json::Reader::parse(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ isBool()

bool Json::Value::isBool | ( |  | ) | const

Definition at line 1325 of file json_value.cpp.

References Json::booleanValue.

## ◆ isConvertibleTo()

bool Json::Value::isConvertibleTo | ( | ValueType | other | ) | const

Definition at line 866 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::InRange(), Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

## ◆ isDouble()

bool Json::Value::isDouble | ( |  | ) | const

Definition at line 1431 of file json_value.cpp.

References Json::intValue, Json::realValue, and Json::uintValue.

## ◆ isInt()

bool Json::Value::isInt | ( |  | ) | const

Definition at line 1327 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::realValue, and Json::uintValue.

## ◆ isInt64()

bool Json::Value::isInt64 | ( |  | ) | const

Definition at line 1369 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::realValue, and Json::uintValue.

## ◆ isIntegral()

bool Json::Value::isIntegral | ( |  | ) | const

Definition at line 1409 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::maxUInt64AsDouble, Json::realValue, and Json::uintValue.

## ◆ isMember() [1/3]

bool Json::Value::isMember | ( | const char * | begin,
|  | const char * | end
| ) |  | const

Same as isMember(String const& key)const.

Definition at line 1260 of file json_value.cpp.

## ◆ isMember() [2/3]

bool Json::Value::isMember | ( | const char * | key | ) | const

Return true if the object has a member named key.

Note
  'key' must be null-terminated.

Definition at line 1264 of file json_value.cpp.

## ◆ isMember() [3/3]

bool Json::Value::isMember | ( | const String & | key | ) | const

Return true if the object has a member named key.

Parameters

  key | may contain embedded nulls.

Definition at line 1267 of file json_value.cpp.

## ◆ isNull()

bool Json::Value::isNull | ( |  | ) | const

Definition at line 1323 of file json_value.cpp.

References Json::nullValue.

## ◆ isNumeric()

bool Json::Value::isNumeric | ( |  | ) | const

Definition at line 1435 of file json_value.cpp.

## ◆ isObject()

bool Json::Value::isObject | ( |  | ) | const

Definition at line 1441 of file json_value.cpp.

References Json::objectValue.

Referenced by Json::Path::make(), Json::Reader::parse(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ isString()

bool Json::Value::isString | ( |  | ) | const

Definition at line 1437 of file json_value.cpp.

References Json::stringValue.

## ◆ isUInt()

bool Json::Value::isUInt | ( |  | ) | const

Definition at line 1346 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::realValue, and Json::uintValue.

## ◆ isUInt64()

bool Json::Value::isUInt64 | ( |  | ) | const

Definition at line 1389 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::maxUInt64AsDouble, Json::realValue, and Json::uintValue.

## ◆ isValidIndex()

bool Json::Value::isValidIndex | ( | ArrayIndex | index | ) | const

Return true if index < size().

Definition at line 1121 of file json_value.cpp.

Referenced by Json::Path::resolve().

Here is the caller graph for this function:

## ◆ nullSingleton()

Value const & Json::Value::nullSingleton | ( |  | ) |
| static

Definition at line 76 of file json_value.cpp.

Referenced by Json::Path::resolve().

Here is the caller graph for this function:

## ◆ operator bool()

Json::Value::operator bool | ( |  | ) | const
| explicit

Return !isNull()

Definition at line 930 of file json_value.cpp.

## ◆ operator!=()

bool Json::Value::operator!= | ( | const Value & | other | ) | const

Definition at line 620 of file json_value.cpp.

## ◆ operator<()

bool Json::Value::operator< | ( | const Value & | other | ) | const

Compare payload only, not comments etc.

Definition at line 520 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_ASSERT, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, type(), and Json::uintValue.

## ◆ operator<=()

bool Json::Value::operator<= | ( | const Value & | other | ) | const

Definition at line 572 of file json_value.cpp.

## ◆ operator=() [1/2]

Value & Json::Value::operator= | ( | const Value & | other | ) |

Note
  Overwrite existing comments. To preserve comments, use swapPayload().

Definition at line 476 of file json_value.cpp.

References swap().

## ◆ operator=() [2/2]

Value & Json::Value::operator= | ( | Value && | other | ) |

Definition at line 481 of file json_value.cpp.

References swap().

## ◆ operator==()

bool Json::Value::operator== | ( | const Value & | other | ) | const

Definition at line 578 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_ASSERT, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, type(), and Json::uintValue.

## ◆ operator>()

bool Json::Value::operator> | ( | const Value & | other | ) | const

Definition at line 576 of file json_value.cpp.

## ◆ operator>=()

bool Json::Value::operator>= | ( | const Value & | other | ) | const

Definition at line 574 of file json_value.cpp.

## ◆ operator[]() [1/9]

Value & Json::Value::operator[] | ( | ArrayIndex | index | ) |

Access an array element (zero based index ).

If the array contains less than index element, then null value are inserted in the array so that its size is index+1. (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 966 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, and Json::nullValue.

## ◆ operator[]() [2/9]

const Value & Json::Value::operator[] | ( | ArrayIndex | index | ) | const

Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 989 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, and Json::nullValue.

## ◆ operator[]() [3/9]

Value & Json::Value::operator[] | ( | const char * | key | ) |

Access an object value by name, create a null member if it does not exist.

Note
  Because of our implementation, keys are limited to 2^30 -1 chars. Exceeding that will cause an exception.

Definition at line 1155 of file json_value.cpp.

## ◆ operator[]() [4/9]

const Value & Json::Value::operator[] | ( | const char * | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Definition at line 1142 of file json_value.cpp.

## ◆ operator[]() [5/9]

Value & Json::Value::operator[] | ( | const StaticString & | key | ) |

Access an object value by name, create a null member if it does not exist.

If the object has no entry for that name, then the member name used to store the new entry is not duplicated. Example of use:

Json::Value object;
static const StaticString code("code");
object[code] = 1234;

Definition at line 1163 of file json_value.cpp.

References Json::StaticString::c_str().

## ◆ operator[]() [6/9]

Value & Json::Value::operator[] | ( | const String & | key | ) |

Access an object value by name, create a null member if it does not exist.

Parameters

  key | may contain embedded nulls.

Definition at line 1159 of file json_value.cpp.

## ◆ operator[]() [7/9]

Value const & Json::Value::operator[] | ( | const String & | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Parameters

  key | may contain embedded nulls.

Definition at line 1148 of file json_value.cpp.

## ◆ operator[]() [8/9]

Value & Json::Value::operator[] | ( | int | index | ) |

Access an array element (zero based index ).

If the array contains less than index element, then null value are inserted in the array so that its size is index+1. (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 982 of file json_value.cpp.

References JSON_ASSERT_MESSAGE.

## ◆ operator[]() [9/9]

const Value & Json::Value::operator[] | ( | int | index | ) | const

Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 1002 of file json_value.cpp.

References JSON_ASSERT_MESSAGE.

## ◆ removeIndex()

bool Json::Value::removeIndex | ( | ArrayIndex | index,
|  | Value * | removed
| ) |  |

Remove the indexed array element.

O(n) expensive operations. Update 'removed' iff removed.

Returns
  true if removed (no exceptions)

Definition at line 1229 of file json_value.cpp.

References Json::arrayValue.

## ◆ removeMember() [1/5]

bool Json::Value::removeMember | ( | const char * | begin,
|  | const char * | end,
|  | Value * | removed
| ) |  |

Same as removeMember(String const& key, Value* removed)

Definition at line 1198 of file json_value.cpp.

References Json::objectValue.

## ◆ removeMember() [2/5]

void Json::Value::removeMember | ( | const char * | key | ) |

Remove and return the named member.

Do nothing if it did not exist.

Precondition
  type() is objectValue or nullValue

Postcondition
  type() is unchanged

Definition at line 1218 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

## ◆ removeMember() [3/5]

bool Json::Value::removeMember | ( | const char * | key,
|  | Value * | removed
| ) |  |

Same as removeMember(const char* begin, const char* end, Value* removed), but 'key' is null-terminated.

Definition at line 1212 of file json_value.cpp.

## ◆ removeMember() [4/5]

void Json::Value::removeMember | ( | const String & | key | ) |

Same as removeMember(const char*)

Parameters

  key | may contain embedded nulls.

Definition at line 1227 of file json_value.cpp.

## ◆ removeMember() [5/5]

bool Json::Value::removeMember | ( | String const & | key,
|  | Value * | removed
| ) |  |

Remove the named map member.

Update 'removed' iff removed.

Parameters

  key | may contain embedded nulls.

Returns
  true iff removed (no exceptions)

Definition at line 1215 of file json_value.cpp.

## ◆ resize()

void Json::Value::resize | ( | ArrayIndex | newSize | ) |

Resize the array to newSize elements.

New elements are initialized to null. May only be called on nullValue or arrayValue.

Precondition
  type() is arrayValue or nullValue

Postcondition
  type() is arrayValue

Definition at line 948 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT, JSON_ASSERT_MESSAGE, and Json::nullValue.

## ◆ setComment() [1/2]

void Json::Value::setComment | ( | const char * | comment,
|  | size_t | len,
|  | CommentPlacement | placement
| ) |  |
| inline

Comments must be //... or /* ... *‍/.

Definition at line 580 of file value.h.

Referenced by Json::Reader::parse().

Here is the caller graph for this function:

## ◆ setComment() [2/2]

void Json::Value::setComment | ( | String | comment,
|  | CommentPlacement | placement
| ) |  |

Comments must be //... or /* ... *‍/.

Definition at line 1475 of file json_value.cpp.

References JSON_ASSERT, JSON_ASSERT_MESSAGE, and placement.

## ◆ setOffsetLimit()

void Json::Value::setOffsetLimit | ( | ptrdiff_t | limit | ) |

Definition at line 1497 of file json_value.cpp.

## ◆ setOffsetStart()

void Json::Value::setOffsetStart | ( | ptrdiff_t | start | ) |

Definition at line 1495 of file json_value.cpp.

## ◆ size()

ArrayIndex Json::Value::size | ( |  | ) | const

Number of values in array or object.

Definition at line 900 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

## ◆ swap()

void Json::Value::swap | ( | Value & | other | ) |

Swap everything.

Definition at line 496 of file json_value.cpp.

References Json::swap().

Referenced by operator=(), and Json::swap().

Here is the caller graph for this function:

## ◆ swapPayload()

void Json::Value::swapPayload | ( | Value & | other | ) |

Swap values but leave comments and source offsets in place.

Definition at line 486 of file json_value.cpp.

References Json::swap().

## ◆ toStyledString()

String Json::Value::toStyledString | ( |  | ) | const

Definition at line 1503 of file json_value.cpp.

References Json::commentBefore, hasComment(), and Json::writeString().

## ◆ type()

ValueType Json::Value::type | ( |  | ) | const

Definition at line 508 of file json_value.cpp.

Referenced by begin(), end(), operator<(), and operator==().

Here is the caller graph for this function:

## Friends And Related Function Documentation

## ◆ ValueIteratorBase

friend class ValueIteratorBase
| friend

Definition at line 177 of file value.h.

## Member Data Documentation

## ◆ allocated_

unsigned int Json::Value::allocated_

Definition at line 641 of file value.h.

## ◆ defaultRealPrecision

const UInt Json::Value::defaultRealPrecision = 17
| static

Default precision for real value for string representation.

Definition at line 229 of file value.h.

## ◆ maxInt

const Int Json::Value::maxInt = Int(UInt(-1) / 2)
| static

Maximum signed int value that can be stored in a Json::Value.

Definition at line 215 of file value.h.

Referenced by Json::duplicateAndPrefixStringValue(), and Json::duplicateStringValue().

## ◆ maxInt64

const Int64 Json::Value::maxInt64 = Int64(UInt64(-1) / 2)
| static

Maximum signed 64 bits int value that can be stored in a Json::Value.

Definition at line 223 of file value.h.

## ◆ maxLargestInt

const LargestInt Json::Value::maxLargestInt = LargestInt(LargestUInt(-1) / 2)
| static

Maximum signed integer value that can be stored in a Json::Value.

Definition at line 208 of file value.h.

Referenced by Json::valueToString().

## ◆ maxLargestUInt

const LargestUInt Json::Value::maxLargestUInt = LargestUInt(-1)
| static

Maximum unsigned integer value that can be stored in a Json::Value.

Definition at line 210 of file value.h.

## ◆ maxUInt

const UInt Json::Value::maxUInt = UInt(-1)
| static

Maximum unsigned int value that can be stored in a Json::Value.

Definition at line 217 of file value.h.

## ◆ maxUInt64

const UInt64 Json::Value::maxUInt64 = UInt64(-1)
| static

Maximum unsigned 64 bits int value that can be stored in a Json::Value.

Definition at line 225 of file value.h.

## ◆ minInt

const Int Json::Value::minInt = Int(~(UInt(-1) / 2))
| static

Minimum signed int value that can be stored in a Json::Value.

Definition at line 213 of file value.h.

## ◆ minInt64

const Int64 Json::Value::minInt64 = Int64(~(UInt64(-1) / 2))
| static

Minimum signed 64 bits int value that can be stored in a Json::Value.

Definition at line 221 of file value.h.

## ◆ minLargestInt

const LargestInt Json::Value::minLargestInt = LargestInt(~(LargestUInt(-1) / 2))
| static

Minimum signed integer value that can be stored in a Json::Value.

Definition at line 206 of file value.h.

Referenced by Json::valueToString().

## ◆ null

Value const & Json::Value::null = Value::nullSingleton()
| static

Definition at line 198 of file value.h.

## ◆ nullRef

Value const & Json::Value::nullRef = Value::nullSingleton()
| static

Definition at line 199 of file value.h.

## ◆ placement

CommentPlacement Json::Value::placement

Initial value:
{
setComment(String(comment, strlen(comment)), placement)

Definition at line 576 of file value.h.

Referenced by getComment(), hasComment(), and setComment().

## ◆ value_type_

unsigned int Json::Value::value_type_

Definition at line 639 of file value.h.

The documentation for this class was generated from the following files:

- include/json/value.h
- src/lib_json/json_value.cpp

Json::Value::placement
CommentPlacement placement
Definition: value.h:576
Json::arrayValue
array value (ordered list)
Definition: value.h:92
Json::Value
Represents a JSON value.
Definition: value.h:176
Json::objectValue
object value (collection of name/value pairs).
Definition: value.h:93
Json::String
std::basic_string< char, std::char_traits< char >, Allocator< char > > String
Definition: config.h:162
Json::Value::setComment
void setComment(const char *comment, size_t len, CommentPlacement placement)
Comments must be //... or /* ... *‍/.
Definition: value.h:580